/*---------------------------------------------------------------------------

  Linux Snarf v1.0.0 - Coded by: dOPEmAN  (dopeman@ducttape.deeznuts.com)

  Here is the source for Linux snarf.. I am sure you can port it to 
  any other unix platform assuming the parallel port address is the 
  same.. 

  Please don't try to steal this software and claim it to be your own.
  If you find any bugs here in the source please email me.. 

---------------------------------------------------------------------------*/

#include <asm/io.h>
#include <stdio.h>
#include <unistd.h>
#include <linux/kernel.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <curses.h>
#include <signal.h>

#define version "v1.0.0"

void grab_raw(unsigned short port,int test,int error);
void analyze_full_message(char *word,int error);
int convert_bin_int(char *bin);
void parse_number(const char *bin,char *type);
void convert_bin_min2(const char *bin,char *intmin);
void convert_bin_min1(const char *bin,char *intmin); 
void convert_bin_esn(const char *bin,char *hexesn); 
void draw_header();
void exitprog(int signal);

int grabs,errors;

short BLACK_BLUE = 1, CYAN_BLUE = 2, WHITE_BLUE = 3;
short RED_BLACK = 4, BLUE_BLACK = 5;

WINDOW *HEADER;
WINDOW *REPORT;

void main(int argc,char **argv)
{

// initialize port, and variables..

    int test, error;

// setup curses windows

    initscr();
    start_color();
    nonl();
    refresh();
    REPORT = newwin(23,80,2,0);
    HEADER = newwin(2,80,0,0);
    scrollok(REPORT,1);

// setup curses colors used in linux snarf
// header colors

   init_pair(WHITE_BLUE, COLOR_WHITE, COLOR_BLUE);
   init_pair(CYAN_BLUE, COLOR_CYAN, COLOR_BLUE);
   init_pair(BLACK_BLUE, COLOR_BLACK, COLOR_BLUE);

// error colors

   init_pair(RED_BLACK, COLOR_RED, COLOR_BLACK);
   init_pair(BLUE_BLACK, COLOR_BLUE, COLOR_BLACK);

// setup signals to watch for

    signal(SIGHUP,&exitprog);
    signal(SIGINT,&exitprog);
    signal(SIGQUIT,&exitprog);
    signal(SIGILL,&exitprog);
    signal(SIGABRT,&exitprog);
    signal(SIGFPE,&exitprog);
    signal(SIGKILL,&exitprog);
    signal(SIGSEGV,&exitprog);
    signal(SIGPIPE,&exitprog);
    signal(SIGALRM,&exitprog);
    signal(SIGTERM,&exitprog);
    signal(SIGUSR1,&exitprog);
    signal(SIGUSR2,&exitprog);
    signal(SIGCONT,&exitprog);
    signal(SIGSTOP,&exitprog);
    signal(SIGTSTP,&exitprog);
    signal(SIGTTIN,&exitprog);
    signal(SIGTTOU,&exitprog);
    signal(SIGTRAP,&exitprog);
    signal(SIGIOT,&exitprog);
    signal(SIGBUS,&exitprog);
    signal(SIGSTKFLT,&exitprog);
    signal(SIGURG,&exitprog);
    signal(SIGIO,&exitprog);
    signal(SIGPOLL,&exitprog);
    signal(SIGXCPU,&exitprog);
    signal(SIGXFSZ,&exitprog);
    signal(SIGVTALRM,&exitprog);
    signal(SIGPROF,&exitprog);
    signal(SIGPWR,&exitprog);


    if (iopl(3)) {
	waddstr(REPORT, "Could not unlock IO port! \n");
	wrefresh(REPORT);
	endwin();
        exit(1);
    }

    grabs=0;
    errors=0;

    test=0;
    error=0;

// Test = 0 - Normal Mode   Test = 1 - Test Mode 
// Noisy = 0 - Clean Grabs Only

    if (argc > 1) 
  	if ((char *)strstr(argv[1],"test")!=NULL) {
	    test=1;    
	    waddstr(REPORT,"Test Mode Enabled!\n");
	    wrefresh(REPORT);
        }
    if (argc > 1) 
  	if ((char *)strstr(argv[1],"response")!=NULL) {
	    test=2;    
	    waddstr(REPORT,"Response Mode Enabled!\n");
	    wrefresh(REPORT);
        }
    if (argc > 1) 
  	if ((char *)strstr(argv[1],"error")!=NULL) {
	    error=1;    
        }
    if (argc > 1) 
  	if ((char *)strstr(argv[1],"help")!=NULL) {
	    waddstr(REPORT,"Command Lines:\n\n");
	    waddstr(REPORT,"      test - Dump the snarfer output to the screen\n");
	    waddstr(REPORT,"      response - Read parallel port responses\n");
	    waddstr(REPORT,"      error - Print Errors\n");
	    waddstr(REPORT,"      help - This screen\n\n");
	    wrefresh(REPORT);
	    endwin();
	    exit(0);
        }

// For some reason draw_header had to be called twice to have the screen
// draw properly the first time..

    if (test < 1) draw_header();
    if (test < 1) draw_header();
    grab_raw(0x378,test,error);

}


void draw_header()
{

// Please do not change these lines, and claim this to be yours.. 
 
	char temp[100];

	sprintf(temp," [Linux Snarf %s] [Coded By: dOPEmAN]          [Grabs: %4d] [Errors: %4d] ",version,grabs,errors);

        mvwaddstr(HEADER,0,0,temp);
 	mvwaddstr(HEADER,1,0," [    MIN    ]  [ ESN  ]  SCM [       TYPE         ]  [         TIME         ]  ");

	mvwchgat(HEADER,0,0,2,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,0,2,18,A_BOLD,WHITE_BLUE,NULL);
	mvwchgat(HEADER,0,20,3,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,0,23,17,A_BOLD,WHITE_BLUE,NULL);
	mvwchgat(HEADER,0,40,11,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,0,51,1,A_NORMAL,CYAN_BLUE,NULL);
	mvwchgat(HEADER,0,52,11,A_NORMAL,WHITE_BLUE,NULL);
	mvwchgat(HEADER,0,63,3,A_NORMAL,CYAN_BLUE,NULL);
	mvwchgat(HEADER,0,66,12,A_NORMAL,WHITE_BLUE,NULL);
	mvwchgat(HEADER,0,78,-1,A_NORMAL,CYAN_BLUE,NULL);

	mvwchgat(HEADER,1,0,2,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,1,2,11,A_BOLD,WHITE_BLUE,NULL);
	mvwchgat(HEADER,1,13,4,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,1,17,6,A_BOLD,WHITE_BLUE,NULL);
	mvwchgat(HEADER,1,23,1,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,1,24,6,A_BOLD,WHITE_BLUE,NULL);
	mvwchgat(HEADER,1,30,1,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,1,31,20,A_BOLD,WHITE_BLUE,NULL);
	mvwchgat(HEADER,1,51,4,A_BOLD,BLACK_BLUE,NULL);
	mvwchgat(HEADER,1,55,23,A_BOLD,WHITE_BLUE,NULL);
	mvwchgat(HEADER,1,76,4,A_BOLD,BLACK_BLUE,NULL);

	wrefresh(HEADER);

}


void grab_raw(unsigned short port,int test,int error)
{

    int a, old_clock, data, clock, dump, dump_bits;
    char dotseq[102], fullmessage[1209];

    data=1;
    clock=1;
    old_clock=1;
    dump=0;
    dump_bits=0;
    dotseq[0]=(char)NULL;
    fullmessage[0]=(char)NULL;

// Set dump to an invalid value if testmode enabled to make sure that 
// data isn't anaylized, just dumped to the srceen..

    if (test == 1) dump=9;

// loop until ctrl-c pressed

    for(;;) {
	    a = inb(port + 1);
		    if (a == 127) {
				    data=0;
				    clock=1;
	     	    }
		    if (a == 119) {
				    data=1;
				    clock=1; 
		    }
		    if (a == 63) {
				    data=0;
				    clock=0;
		    }
		    if (a == 55) {
				    data=1;
				    clock=0;
		    }
            
// Check the old clock setting, if it has changed to low(0), or high(1) again
// read the data bit.. If not, don't do anything, and re-loop..

	    if ((clock != old_clock) && (clock==1)) {
			sprintf(dotseq,"%s%d",dotseq,data);
			if (strlen(dotseq)>100)
			    dotseq[0]=(char)NULL;	 
			
// If test mode is enabled dump the data to the screen

			if (test == 1) 
				fprintf(stdout,"%d",data);
			if (test == 2) 
				fprintf(stdout,"%d ",a);

// Look for Dotting Sequence.. When found set dump = to 1, reset dump_bits

			if (dump == 0) {
				if((char *)strstr(dotseq,"010101010101010101010")!=NULL) {
					dotseq[0]=(char)NULL;		
                               		dump=1;
					dump_bits=0;
					}
			}

// Look for 11-Bit Work Sync, when found set dump=2, and reset dump_bits

			if (dump == 1) {
				dump_bits++; 
				if((char *)strstr(dotseq,"11100010010")!=NULL) {
					dotseq[0]=(char)NULL;
                                  	dump=2;
					dump_bits=0;
					}

// If total of 40 bits are read, and the 11-bit seq is not found, then there
// is no message coming, so set dump back to 0, and look for the dotting
// sequence again..

				if (dump_bits > 40) 
					dump=0;
			}

// Now that the dotting sequence has been found, and the 11-bit work sync
// has been found dump the next 1207 bits.. Once all 1207 bits are read
// anaylize the data, and then set dump back to 0 to start looking for the
// next pair.. 

			if (dump == 2) {
				dump_bits++;
				if (dump_bits <= 1207)
					fullmessage[dump_bits-1]=(char)data+48;
				if (dump_bits > 1207) {	
					analyze_full_message(fullmessage,error);
					dump=0;
  				        fullmessage[0]=(char)NULL;
				}	
		       } 
		}
			  
 	  old_clock = clock;
	  }

}

void analyze_full_message(char *word,int error) 
{

   int x,y,z;
   char border_type[4], bscm[5][6], bmin1[5][26], bmin2[5][12], besn[5][34];
   char scm[10], dcc[3], min2[4], min1[10], esn[10], type[300], temp[100];
   FILE *esnlog;
   FILE *fulllog;
   time_t current_time;
   

// Make sure word is synced properly.. Sometimes the word gets shifted an
// extra character forward, if you don't sync you will get matching words
// but invalid pairs.. I am not sure if this is a weakness in the software
// or the hardware.. This looks for the reserved bit in the first word, 
// and the first bit, and makes sure they are both one, if not it addes
// an extra character to the front of the string, and tries again..

   if ((word[7] != '1') && (word[248] != '0') && (word[489]!='1') && (word[14]!='0'))  
   {
  	sprintf(word,"0%s",word);
	if ((word[7] != '1') && (word[248] != '0') && (word[489]!='1') && (word[14]!='0'))
	{
            sprintf(word,"0%s",word);
            if((word[7]!='1') && (word[248] != '0') && (word[489]!='1') && (word[14]!='0'))
            {
               sprintf(word,"0%s",word);
               if((word[7]!='1') && (word[248] != '0') && (word[489]!='1') && (word[14]!='0'))
               {
	  	   if (error == 1) {
			waddstr(REPORT,"ERROR: Word could not be syncned..\n");
                   	wrefresh(REPORT);
			}
		   errors++;  
		   draw_header();
		   return;
               }
            }
	}
   }       

// Parse out Coded Digital Color Code
// This method isn't always correct, but when a valid DCC is recieved
// it works..

   esnlog=fopen("pairs","a+");    
   fulllog=fopen("full-log","a+");
    
   sprintf(dcc,"%c%c",word[3],word[4]);

// Parse out Order Type

   border_type[0] = word[12];
   border_type[1] = word[60];
   border_type[2] = word[108];
   border_type[3] = word[156];
   border_type[4] = word[204];

// Check if Order Types Match, and if so set type to determine action

   if ((border_type[0]==border_type[1]) && (border_type[1]==border_type[2])
      && (border_type[2]==border_type[3]) && (border_type[3]==border_type[4]))
   {
   if (border_type[0] == '1')
    	parse_number(word,type);
   if (border_type[0] == '0')
   	sprintf(type,"Order/Page Response");
   }
   else
   {
	sprintf(type,"ERROR");  
	if (error == 1) {
		waddstr(REPORT,"WARNING: Order Types don't match\n");
		wrefresh(REPORT);
		}
   }     

// Parse out Station Class Mark 

   for (y=0;y<5;y++) {
     z = y*48; 
     for (x=(z+16);x<(z+20);x++) 
	   bscm[y][x-(16+z)]=word[x]; 
   }
   bscm[0][4]='\0';
   bscm[1][4]='\0';
   bscm[2][4]='\0';
   bscm[3][4]='\0';
   bscm[4][4]='\0';
 
// Compare Station Class Mark, if they match convert..

   if ((strcmp(bscm[0],bscm[1])==0) && (strcmp(bscm[1],bscm[2])==0)
      && (strcmp(bscm[2],bscm[3])==0) && (strcmp(bscm[3],bscm[4])==0))
   {
   sprintf(scm,"%d",(convert_bin_int(bscm[0])));
   }
   else
   {
	sprintf(scm,"ER");
	if (error == 1) {
		waddstr(REPORT,"WARNING: Station Class Marks Don't Match!\n");
		wrefresh(REPORT);
		}
   }

// Parse out Min1 

   for (y=0;y<5;y++) {
     z = y*48; 
     for (x=(z+20);x<(z+44);x++)  //19, 43 
	   bmin1[y][x-(20+z)]=word[x]; 
   }
   bmin1[0][24]='\0';
   bmin1[1][24]='\0';
   bmin1[2][24]='\0';
   bmin1[3][24]='\0';
   bmin1[4][24]='\0';

// Compare MIN1s and convert to phone numbers if they match..

   if ((strcmp(bmin1[0],bmin1[1])==0) && (strcmp(bmin1[1],bmin1[2])==0)
      && (strcmp(bmin1[2],bmin1[3])==0) && (strcmp(bmin1[3],bmin1[4])==0))
   {  
   	convert_bin_min1(bmin1[0],min1);
   }
   else 
   {
	if (error == 1) { 
		waddstr(REPORT,"ERROR: MIN1 Compare Error!\n");
	        wrefresh(REPORT);
		}
	fclose(esnlog);
	fclose(fulllog);
	errors++;
        draw_header();
	return;
   } 
   if (min1[strlen(min1)]!='\0')
	min1[strlen(min1)]='\0';


// Parse out Min2

   for (y=0;y<5;y++) {
     z = y*48; 
     for (x=(z+274);x<(z+284);x++) //273,283  
	   bmin2[y][x-(274+z)]=word[x]; 
   }
   bmin2[0][10]='\0';
   bmin2[1][10]='\0';
   bmin2[2][10]='\0';
   bmin2[3][10]='\0';
   bmin2[4][10]='\0';

// Convert Binary 10-Bit MIN2 to Character 3 digit MIN2 if all min2's match

   if ((strcmp(bmin2[0],bmin2[1])==0) && (strcmp(bmin2[1],bmin2[2])==0)
       && (strcmp(bmin2[2],bmin2[3])==0) && (strcmp(bmin2[3],bmin2[4])==0))
   {  
	convert_bin_min2(bmin2[0],min2);
   }
   else 
   {
	if (error == 1) {
		waddstr(REPORT,"ERROR: MIN2 Compare Error\n");
		wrefresh(REPORT);
		}
        fclose(esnlog);
	fclose(fulllog);
	errors++;
	draw_header();
	return;
   }
   if (min2[strlen(min2)]!='\0')
	min2[strlen(min2)]='\0';


// Parse out ESN

   for (y=0;y<5;y++) {
     z = y*48;
     for (x=(z+492);x<(z+524);x++)  //491,523
	   besn[y][x-(492+z)]=word[x]; 
   }
   besn[0][32]='\0';
   besn[1][32]='\0';
   besn[2][32]='\0';
   besn[3][32]='\0';
   besn[4][32]='\0';

// Convert ESN from Binary to Hex if all ESN's match..

   if ((strcmp(besn[0],besn[1])==0) && (strcmp(besn[1],besn[2])==0)
      && (strcmp(besn[2],besn[3])==0) && (strcmp(besn[3],besn[4])==0))
   {  
	convert_bin_esn(besn[0],esn);
   }
   else 
   {
	if (error == 1) {
		waddstr(REPORT,"ERROR: ESN Compare Error\n");
		wrefresh(REPORT);
		}
        fclose(esnlog);
	fclose(fulllog);
	errors++;
	draw_header();
	return;
   }
   if (esn[strlen(esn)]!='\0')
	esn[strlen(esn)]='\0';

// Check to make sure ESN is valid.. This might not work to well when grabbing
// authenticated pairs, so it may need to be taken out to get the encrypted
// ESN..

   if (esn[0] == 'F')
   {
 	if (error == 1) {
		waddstr(REPORT,"ERROR: Bad ESN header\n");
		wrefresh(REPORT);
		}
	errors++;
       	draw_header();
	return;
   }

   for (x=0;x<8;x++){
	   if (esn[0] == (char) x+48)
		{
	 	if (error == 1) {
			waddstr(REPORT,"ERROR: Bad ESN header\n");
			wrefresh(REPORT);
			}
		errors++;
		draw_header();
		return;	
		}
   }


// Print reports, and save logs

   grabs++;
   current_time=time(NULL);
   sprintf(temp," (%s)%s  %s  %2s  %-22s  %s",min2,min1,esn,scm,type,ctime(&current_time));

   waddstr(REPORT,temp);
   fprintf(fulllog," (%s)%s  %s  %2s  %-22s  %s",min2,min1,esn,scm,type,ctime(&current_time));
   fprintf(esnlog,"(%s)%s       %s        %s",min2,min1,esn,ctime(&current_time));
   
   wrefresh(REPORT);
   draw_header();  

   fclose(esnlog);
   fclose(fulllog);
}

int convert_bin_int(char *bin) 
{

   int converted,c1,c2,c3,c4;
 
   c1=bin[0]-48;
   c2=bin[1]-48;
   c3=bin[2]-48;
   c4=bin[3]-48;
   converted=(c1*8)+(c2*4)+(c3*2)+c4;
   return converted;

}

void convert_bin_min1(const char *bin,char *intmin) 
{
 
  int minb,c1,c2,c3,c4,x;
  char mina[10],minc[10],temp[10];

// Convert First 3 Digits, using MIN2 fucntion.
   for (x=0;x<10;x++) 
       temp[x]=bin[x];
   temp[x]='\0';
   convert_bin_min2(temp,mina);
   if(mina[strlen(mina)]!='\0')
      mina[strlen(mina)]='\0';
// Convert Middle Digit

   c1=bin[10]-48;
   c2=bin[11]-48;
   c3=bin[12]-48;
   c4=bin[13]-48;
   minb=(c1*8)+(c2*4)+(c3*2)+c4;
   if (minb>=10) minb=0;
   
// Convert Last 3 Digits, using MIN2 function.

   for (x=0;x<10;x++) 
       temp[x]=bin[x+14]; 
   temp[x]='\0';
   convert_bin_min2(temp,minc);
   if(minc[strlen(minc)]!='\0')
      minc[strlen(minc)]='\0';

// Merge Strings into Phone Number

  sprintf(intmin,"%s-%d%s",mina,minb,minc);

}

void convert_bin_min2(const char *bin,char *intmin) 
{

   int converted,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10;
   int con1,con2,con3;
   c1=bin[0]-48;
   c2=bin[1]-48;
   c3=bin[2]-48;
   c4=bin[3]-48;
   c5=bin[4]-48;
   c6=bin[5]-48;
   c7=bin[6]-48;
   c8=bin[7]-48;
   c9=bin[8]-48;
   c10=bin[9]-48;

   converted=(c1*512)+(c2*256)+(c3*128)+(c4*64)+(c5*32)+(c6*16)+(c7*8)+(c8*4)+(c9*2)+c10;

// Parse each converted digit
   con1=converted%10+1;
   con2=converted%100/10+1;
   con3=converted%1000/100+1;

// Check for exsistince of 10's and convert them to 0's

   if (con1>=10) con1=0;
   if (con2>=10) con2=0;
   if (con3>=10) con3=0;

   sprintf(intmin,"%d%d%d",con3,con2,con1);

}


void convert_bin_esn(const char *bin,char *hexesn) 
{

  int x;
  char besn[9][6];
  char esn[10]; 

  for (x=0;x<4;x++) 
	   besn[0][x]=bin[x]; 
  for (x=4;x<8;x++) 
	   besn[1][x-4]=bin[x]; 
  for (x=8;x<12;x++) 
	   besn[2][x-8]=bin[x]; 
  for (x=12;x<16;x++) 
	   besn[3][x-12]=bin[x]; 
  for (x=16;x<20;x++) 
	   besn[4][x-16]=bin[x]; 
  for (x=20;x<24;x++) 
	   besn[5][x-20]=bin[x]; 
  for (x=24;x<28;x++) 
	   besn[6][x-24]=bin[x]; 
  for (x=28;x<32;x++) 
	   besn[7][x-28]=bin[x];
 
   besn[0][4]='\0';
   besn[1][4]='\0';
   besn[2][4]='\0';
   besn[3][4]='\0';
   besn[4][4]='\0';
   besn[5][4]='\0';
   besn[6][4]='\0';
   besn[7][4]='\0';


  for (x=0;x<8;x++)
    switch(convert_bin_int(besn[x]))
    {
      case 0: esn[x]='0'; 
	      break;
      case 1: esn[x]='1'; 
	      break;
      case 2: esn[x]='2'; 
	      break;
      case 3: esn[x]='3'; 
	      break;
      case 4: esn[x]='4'; 
	      break;
      case 5: esn[x]='5'; 
	      break;
      case 6: esn[x]='6'; 
	      break;
      case 7: esn[x]='7'; 
	      break;
      case 8: esn[x]='8'; 
	      break;
      case 9: esn[x]='9'; 
	      break;
      case 10: esn[x]='A'; 
	      break;
      case 11: esn[x]='B'; 
	      break;
      case 12: esn[x]='C'; 
	      break;
      case 13: esn[x]='D'; 
	      break;
      case 14: esn[x]='E'; 
	      break;
      case 15: esn[x]='F'; 
	      break;
      default: esn[x]='0';
 	      break;
   }

  sprintf(hexesn,"%c%c%c%c%c%c%c%c",esn[0],esn[1],esn[2],esn[3],esn[4],esn[5],esn[6],esn[7]);
 
}

void parse_number(const char *bin,char *type)
{

   int x,y,z;
   char bdialed[18][6];
   int dialed[20];

// parse out digits one by one from word 1

   for (y=0;y<16;y++) {
     z = y*4; 
     for (x=732+z;x<736+z;x++) 
	   bdialed[y][x-(732+z)]=bin[x]; 
   }
   bdialed[0][4]='\0';
   bdialed[1][4]='\0';
   bdialed[2][4]='\0';
   bdialed[3][4]='\0';
   bdialed[4][4]='\0';
   bdialed[5][4]='\0';
   bdialed[6][4]='\0';
   bdialed[7][4]='\0';

// Convert Binary numbers to hex..

   dialed[0]=(convert_bin_int(bdialed[0]));
   dialed[1]=(convert_bin_int(bdialed[1]));
   dialed[2]=(convert_bin_int(bdialed[2]));
   dialed[3]=(convert_bin_int(bdialed[3]));
   dialed[4]=(convert_bin_int(bdialed[4]));
   dialed[5]=(convert_bin_int(bdialed[5]));
   dialed[6]=(convert_bin_int(bdialed[6]));
   dialed[7]=(convert_bin_int(bdialed[7]));

// Check for errors in dialed number, and convert 10s,11s, and 12s to 0,*,#

   sprintf(type,"Dialed: ");

// If the first bit is 0, the assume that it's a registration..

   if (dialed[0] == 0)	
	{
	sprintf(type,"Registration");
	return;
	}

   for (x=0;x<8;x++) {
	if (dialed[x] > 12)
		{
		// If an invalid character is given assume it's a registration
		sprintf(type,"Registration");
		return;
		}
	else if (dialed[x] == 0)
		return;
	else if (dialed[x] == 10)
		sprintf(type,"%s0",type);
	else if (dialed[x] == 11)
		sprintf(type,"%s*",type);
	else if (dialed[x] == 12)
		sprintf(type,"%s#",type);
	else sprintf(type,"%s%d",type,dialed[x]);
   }

// check to see if the next dialed number word needs to be decoded.. 
// If so do it..

	if (dialed[7] != 0)
	{

// Parse out number dialed from word 2

   for (y=8;y<16;y++) {
     z = y*4; 
     for (x=972+z;x<976+z;x++) 
	   bdialed[y][x-(972+z)]=bin[x]; 
   }
   bdialed[8][4]='\0';
   bdialed[9][4]='\0';
   bdialed[10][4]='\0';
   bdialed[11][4]='\0';
   bdialed[12][4]='\0';
   bdialed[13][4]='\0';
   bdialed[14][4]='\0';
   bdialed[15][4]='\0';

// Convert Binary to Decimal..

   dialed[8]=(convert_bin_int(bdialed[8]));
   dialed[9]=(convert_bin_int(bdialed[9]));
   dialed[10]=(convert_bin_int(bdialed[10]));
   dialed[11]=(convert_bin_int(bdialed[11]));
   dialed[12]=(convert_bin_int(bdialed[12]));
   dialed[13]=(convert_bin_int(bdialed[13]));
   dialed[14]=(convert_bin_int(bdialed[14]));
   dialed[15]=(convert_bin_int(bdialed[15]));

// Convert integers to *,#,0, etc.. 

   for (x=8;x<16;x++) {
	if (dialed[x] > 12)
		{
		//sprintf(type,"Dialed: ERROR > 12");
		return;
		}
	else if (dialed[x] == 0)
		return;
	else if (dialed[x] == 10)
		sprintf(type,"%s0",type);
	else if (dialed[x] == 11)
		sprintf(type,"%s*",type);
	else if (dialed[x] == 12)
		sprintf(type,"%s#",type);
	else sprintf(type,"%s%d",type,dialed[x]);
   }
 }
 
}

void exitprog(int signal)
{

    endwin();
    system("clear");
    fprintf(stdout,"Exiting Linux Snarf %s\n",version);
    fprintf(stdout,"Grabs: %d   Errors: %d\n\n",grabs,errors);
    exit(0);

}

